/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_GroupOp_h__
#define __operator_GroupOp_h__

namespace fe
{

/**************************************************************************//**
    @brief Manipulate point and primitive groups

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT GroupOp:
	public OperatorSurfaceCommon,
	public Initialize<GroupOp>
{
	public:
				GroupOp(void)												{}
virtual			~GroupOp(void)												{}

		void	initialize(void);

				//* As HandlerI
virtual void	handle(Record& a_rSignal);

	private:
		void	groupElement(I32 a_index);

		sp<SurfaceAccessibleI>	m_spOutputAccessible;
		sp<SurfaceAccessorI>	m_spElementAttribute;
		String					m_defaultGroup;
		BWORD					m_doPrimitive;

		std::map<String, sp<SurfaceAccessorI> >		m_groupMap;
};

} // namespace

#endif /* __operator_GroupOp_h__ */

