/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_SubdivideOp_h__
#define __operator_SubdivideOp_h__

namespace fe
{

/**************************************************************************//**
    @brief Increase resolution of a mesh

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT SubdivideOp:
	public OperatorSurfaceCommon,
	public Initialize<SubdivideOp>
{
	public:
				SubdivideOp(void)											{}
virtual			~SubdivideOp(void)											{}

		void	initialize(void);

				//* As BindI
virtual	void	bind(sp<SignalerI> a_spSignalerI,sp<Layout> a_spLayout);
				//* As HandlerI
virtual void	handle(Record& a_rSignal);

	private:

	class Edge
	{
		public:
								Edge(void):
									m_pointIndex(-1)						{}

			std::set<I32>		m_faceSet;
			I32					m_pointIndex;
	};

		sp<OperatorSurfaceI>	m_spSurfaceNormalOp;
};

} // namespace

#endif /* __operator_SubdivideOp_h__ */
